<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: ESP32CPP::GPIO Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><b>ESP32CPP</b></li><li class="navelem"><a class="el" href="classESP32CPP_1_1GPIO.html">GPIO</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classESP32CPP_1_1GPIO-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">ESP32CPP::GPIO Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Interface to GPIO functions.  
 <a href="classESP32CPP_1_1GPIO.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="GPIO_8h_source.html">GPIO.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:adf4319c3ae87b69012c0c4696dc69081"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classESP32CPP_1_1GPIO.html#adf4319c3ae87b69012c0c4696dc69081">addISRHandler</a> (gpio_num_t pin, gpio_isr_t handler, void *pArgs)</td></tr>
<tr class="memdesc:adf4319c3ae87b69012c0c4696dc69081"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add an ISR handler to the pin.  <a href="#adf4319c3ae87b69012c0c4696dc69081">More...</a><br /></td></tr>
<tr class="separator:adf4319c3ae87b69012c0c4696dc69081"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9c168a825e68fa07f9d707c5832230f0"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classESP32CPP_1_1GPIO.html#a9c168a825e68fa07f9d707c5832230f0">high</a> (gpio_num_t pin)</td></tr>
<tr class="memdesc:a9c168a825e68fa07f9d707c5832230f0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the pin high.  <a href="#a9c168a825e68fa07f9d707c5832230f0">More...</a><br /></td></tr>
<tr class="separator:a9c168a825e68fa07f9d707c5832230f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a977756d253f25761e2412d8c191fe7da"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classESP32CPP_1_1GPIO.html#a977756d253f25761e2412d8c191fe7da">interruptDisable</a> (gpio_num_t pin)</td></tr>
<tr class="memdesc:a977756d253f25761e2412d8c191fe7da"><td class="mdescLeft">&#160;</td><td class="mdescRight">Disable interrupts on the named pin.  <a href="#a977756d253f25761e2412d8c191fe7da">More...</a><br /></td></tr>
<tr class="separator:a977756d253f25761e2412d8c191fe7da"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65c96a8cba32614babdc86c0eab9bd12"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classESP32CPP_1_1GPIO.html#a65c96a8cba32614babdc86c0eab9bd12">interruptEnable</a> (gpio_num_t pin)</td></tr>
<tr class="memdesc:a65c96a8cba32614babdc86c0eab9bd12"><td class="mdescLeft">&#160;</td><td class="mdescRight">Enable interrupts on the named pin.  <a href="#a65c96a8cba32614babdc86c0eab9bd12">More...</a><br /></td></tr>
<tr class="separator:a65c96a8cba32614babdc86c0eab9bd12"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae715e46a8c6d0ba0ebe3d15de9cc7db0"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classESP32CPP_1_1GPIO.html#ae715e46a8c6d0ba0ebe3d15de9cc7db0">inRange</a> (gpio_num_t pin)</td></tr>
<tr class="memdesc:ae715e46a8c6d0ba0ebe3d15de9cc7db0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Determine if the pin is a valid pin for an ESP32 (i.e. is it in range).  <a href="#ae715e46a8c6d0ba0ebe3d15de9cc7db0">More...</a><br /></td></tr>
<tr class="separator:ae715e46a8c6d0ba0ebe3d15de9cc7db0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83984b2c70af70005b39071ea88fb45c"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classESP32CPP_1_1GPIO.html#a83984b2c70af70005b39071ea88fb45c">low</a> (gpio_num_t pin)</td></tr>
<tr class="memdesc:a83984b2c70af70005b39071ea88fb45c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the pin low.  <a href="#a83984b2c70af70005b39071ea88fb45c">More...</a><br /></td></tr>
<tr class="separator:a83984b2c70af70005b39071ea88fb45c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:add68250ce86665c502405a353ef1c870"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classESP32CPP_1_1GPIO.html#add68250ce86665c502405a353ef1c870">read</a> (gpio_num_t pin)</td></tr>
<tr class="memdesc:add68250ce86665c502405a353ef1c870"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read a value from the given pin.  <a href="#add68250ce86665c502405a353ef1c870">More...</a><br /></td></tr>
<tr class="separator:add68250ce86665c502405a353ef1c870"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd43e7bc27885215900f7780197a0247"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classESP32CPP_1_1GPIO.html#afd43e7bc27885215900f7780197a0247">setInput</a> (gpio_num_t pin)</td></tr>
<tr class="memdesc:afd43e7bc27885215900f7780197a0247"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the pin as input.  <a href="#afd43e7bc27885215900f7780197a0247">More...</a><br /></td></tr>
<tr class="separator:afd43e7bc27885215900f7780197a0247"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af649387f8f64c1abdc66d3b93c2e966b"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classESP32CPP_1_1GPIO.html#af649387f8f64c1abdc66d3b93c2e966b">setInterruptType</a> (gpio_num_t pin, gpio_int_type_t intrType)</td></tr>
<tr class="memdesc:af649387f8f64c1abdc66d3b93c2e966b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the interrupt type. The type of interrupt can be one of:  <a href="#af649387f8f64c1abdc66d3b93c2e966b">More...</a><br /></td></tr>
<tr class="separator:af649387f8f64c1abdc66d3b93c2e966b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac1599d926502a487e0e7518dc343a833"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classESP32CPP_1_1GPIO.html#ac1599d926502a487e0e7518dc343a833">setOutput</a> (gpio_num_t pin)</td></tr>
<tr class="memdesc:ac1599d926502a487e0e7518dc343a833"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the pin as output.  <a href="#ac1599d926502a487e0e7518dc343a833">More...</a><br /></td></tr>
<tr class="separator:ac1599d926502a487e0e7518dc343a833"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6ed6d7b43b7eb1b8ec5b3cb192a58598"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classESP32CPP_1_1GPIO.html#a6ed6d7b43b7eb1b8ec5b3cb192a58598">write</a> (gpio_num_t pin, bool value)</td></tr>
<tr class="memdesc:a6ed6d7b43b7eb1b8ec5b3cb192a58598"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a value to the given pin.  <a href="#a6ed6d7b43b7eb1b8ec5b3cb192a58598">More...</a><br /></td></tr>
<tr class="separator:a6ed6d7b43b7eb1b8ec5b3cb192a58598"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad2538618676a072e7b80778df97e3341"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classESP32CPP_1_1GPIO.html#ad2538618676a072e7b80778df97e3341">writeByte</a> (gpio_num_t pins[], uint8_t value, int bits)</td></tr>
<tr class="memdesc:ad2538618676a072e7b80778df97e3341"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write up to 8 bits of data to a set of pins.  <a href="#ad2538618676a072e7b80778df97e3341">More...</a><br /></td></tr>
<tr class="separator:ad2538618676a072e7b80778df97e3341"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Interface to GPIO functions. </p>
<p>The GPIO functions encapsulate the GPIO access. The GPIOs available to us are 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,21,23,25,26,27,32,33,34,35,36,37,38,39.</p>
<p>The GPIOs of 34,35,36,37,38 and 39 are input only.</p>
<p>Note that we must not use <code>int</code> values for the pin numbers but instead use the <code>gpio_num_t</code>. There are constants defined for these of the form <code>GPIO_NUM_xx</code>.</p>
<p>To toggle a pin we might code:</p>
<div class="fragment"><div class="line"><a class="code" href="classESP32CPP_1_1GPIO.html#ac1599d926502a487e0e7518dc343a833">ESP32CPP::GPIO::setOutput</a>(pin);</div><div class="line"><a class="code" href="classESP32CPP_1_1GPIO.html#a9c168a825e68fa07f9d707c5832230f0">ESP32CPP::GPIO::high</a>(pin);</div><div class="line"><a class="code" href="classESP32CPP_1_1GPIO.html#a83984b2c70af70005b39071ea88fb45c">ESP32CPP::GPIO::low</a>(pin);</div></div><!-- fragment --> </div><h2 class="groupheader">Member Function Documentation</h2>
<a id="adf4319c3ae87b69012c0c4696dc69081"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adf4319c3ae87b69012c0c4696dc69081">&#9670;&nbsp;</a></span>addISRHandler()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ESP32CPP::GPIO::addISRHandler </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>pin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">gpio_isr_t&#160;</td>
          <td class="paramname"><em>handler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>pArgs</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Add an ISR handler to the pin. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pin</td><td>The pin to have the ISR associated with it. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">handler</td><td>The function to be invoked when the interrupt is detected. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pArgs</td><td>Optional arguments to pass to the handler. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a9c168a825e68fa07f9d707c5832230f0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9c168a825e68fa07f9d707c5832230f0">&#9670;&nbsp;</a></span>high()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ESP32CPP::GPIO::high </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>pin</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the pin high. </p>
<p>Ensure that the pin is set to be output prior to calling this method.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pin</td><td>The pin to be set high. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="ae715e46a8c6d0ba0ebe3d15de9cc7db0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae715e46a8c6d0ba0ebe3d15de9cc7db0">&#9670;&nbsp;</a></span>inRange()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool ESP32CPP::GPIO::inRange </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>pin</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Determine if the pin is a valid pin for an ESP32 (i.e. is it in range). </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pin</td><td>The pin number to validate. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The value of true if the pin is valid and false otherwise. </dd></dl>

</div>
</div>
<a id="a977756d253f25761e2412d8c191fe7da"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a977756d253f25761e2412d8c191fe7da">&#9670;&nbsp;</a></span>interruptDisable()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ESP32CPP::GPIO::interruptDisable </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>pin</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Disable interrupts on the named pin. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pin</td><td>The pin to disable interrupts upon. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a65c96a8cba32614babdc86c0eab9bd12"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a65c96a8cba32614babdc86c0eab9bd12">&#9670;&nbsp;</a></span>interruptEnable()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ESP32CPP::GPIO::interruptEnable </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>pin</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Enable interrupts on the named pin. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pin</td><td>The pin to enable interrupts upon. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a83984b2c70af70005b39071ea88fb45c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a83984b2c70af70005b39071ea88fb45c">&#9670;&nbsp;</a></span>low()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ESP32CPP::GPIO::low </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>pin</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the pin low. </p>
<p>Ensure that the pin is set to be output prior to calling this method.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pin</td><td>The pin to be set low. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="add68250ce86665c502405a353ef1c870"></a>
<h2 class="memtitle"><span class="permalink"><a href="#add68250ce86665c502405a353ef1c870">&#9670;&nbsp;</a></span>read()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool ESP32CPP::GPIO::read </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>pin</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Read a value from the given pin. </p>
<p>Ensure the pin is set as input before calling this method. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pin</td><td>The pin to read from. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if the pin is high, false if the pin is low. </dd></dl>

</div>
</div>
<a id="afd43e7bc27885215900f7780197a0247"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afd43e7bc27885215900f7780197a0247">&#9670;&nbsp;</a></span>setInput()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ESP32CPP::GPIO::setInput </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>pin</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the pin as input. </p>
<p>Set the direction of the pin as input. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pin</td><td>The pin to set as input. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="af649387f8f64c1abdc66d3b93c2e966b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af649387f8f64c1abdc66d3b93c2e966b">&#9670;&nbsp;</a></span>setInterruptType()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ESP32CPP::GPIO::setInterruptType </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>pin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">gpio_int_type_t&#160;</td>
          <td class="paramname"><em>intrType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the interrupt type. The type of interrupt can be one of: </p>
<ul>
<li>GPIO_INTR_ANYEDGE</li>
<li>GPIO_INTR_DISABLE</li>
<li>GPIO_INTR_NEGEDGE</li>
<li>GPIO_INTR_POSEDGE</li>
<li>GPIO_INTR_LOW_LEVEL</li>
<li>GPIO_INTR_HIGH_LEVEL</li>
</ul>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pin</td><td>The pin to set the interrupt upon. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">intrType</td><td>The type of interrupt. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="ac1599d926502a487e0e7518dc343a833"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac1599d926502a487e0e7518dc343a833">&#9670;&nbsp;</a></span>setOutput()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ESP32CPP::GPIO::setOutput </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>pin</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the pin as output. </p>
<p>Set the direction of the pin as output. Note that pins 34 through 39 are input only and can <b>not</b> be set as output. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pin</td><td>The pin to set as output. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a6ed6d7b43b7eb1b8ec5b3cb192a58598"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6ed6d7b43b7eb1b8ec5b3cb192a58598">&#9670;&nbsp;</a></span>write()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ESP32CPP::GPIO::write </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>pin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Write a value to the given pin. </p>
<p>Ensure that the pin is set as output before calling this method. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pin</td><td>The gpio pin to change. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">value</td><td>The value to be written to the pin. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="ad2538618676a072e7b80778df97e3341"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad2538618676a072e7b80778df97e3341">&#9670;&nbsp;</a></span>writeByte()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ESP32CPP::GPIO::writeByte </td>
          <td>(</td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>pins</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>bits</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Write up to 8 bits of data to a set of pins. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">pins</td><td>An array of pins to set their values. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">value</td><td>The data value to write. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">bits</td><td>The number of bits to write. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="GPIO_8h_source.html">GPIO.h</a></li>
<li>GPIO.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
